import torch
from model import LFLSTM,LFLSTM_2


import argparse



torch.manual_seed(123)
torch.cuda.manual_seed_all(123)

def main(args,word2id):

    text_size = 300
    #visual_size = 47
    visual_size = 711
    acoustic_size = 74

    # define some model settings and hyper-parameters
    input_sizes = [text_size, visual_size, acoustic_size]
    hidden_sizes = [100, 200, 200]
    #fc1_size = np.array(hidden_sizes) // 2
    fc1_size = [128,128,128]
    dropout = 0.1
    output_size = 2
    grad_clip_value = 1.0
    weight_decay = 0.

    model_dict = dict()
    optimizer_dict = dict()
    model_test_dict = dict()
    model_test_visual = LFLSTM_2(input_sizes[1], 10, hidden_sizes[1], fc1_size[1], output_size,
                                         dropout, mode='visual').cuda()
    torch.save(model_test_visual, 'model_visual.tar')
    model_test_visual = torch.load('model_visual.tar').cuda()
    model_test_visual.eval()


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='MOSI')
    parser.add_argument('--device', type=int)
    parser.add_argument('--epoch', type=int, default=30, help="Number of epochs to train.")
    parser.add_argument('--mig', default=False, action='store_true', help='MIG or not')
    parser.add_argument('--alpha', type=float, default=1.0, help='hyper-parameters for MIG')
    parser.add_argument('--seed', type=int, help='random seed')

    args = parser.parse_args()
    main(args,10)
