import torch.nn as nn
import torch
import torch.nn.functional as F
from main import args
from syn_data_guassian import view_train


# torch.manual_seed(5678)
# np.random.seed(5678)
class Logistic(nn.Module):

    def __init__(self,size):
        super(Logistic,self).__init__()

        self.fc1 = nn.Linear(size,10)
        self.bn1 = nn.BatchNorm1d(10)
        self.fc2 = nn.Linear(10,2)

    def forward(self, x,vat = False,mig=False,hgr = False):

        x = self.fc1(x)
        #x = self.bn1(x)
        x = self.fc2(F.relu(x))

        if vat:
            return x
        elif mig:
            return F.softmax(x,dim = 1)
        else:
            return F.log_softmax(x,dim = 1)

class HGR_Linear(nn.Module):

    def __init__(self):
        super(HGR_Linear,self).__init__()

        self.fc1 = nn.Linear(2 * args.modalities,args.classes)

    def forward(self, x):

        x = self.fc1(x)

        return F.log_softmax(x,dim = 1)


H_Linear = HGR_Linear().to(args.device)
H_Optimizer = torch.optim.Adam(H_Linear.parameters(), lr = args.lr)
Net = {i: Logistic(view_train[i].shape[1]).to(args.device) for i in range(1,args.modalities+1)}
Optimizer = {i: torch.optim.Adam(Net[i].parameters(), lr = args.lr) for i in range(1,args.modalities+1)}
Scheduler = {i: torch.optim.lr_scheduler.StepLR(Optimizer[i],step_size=400, gamma=1) for i in range(1,args.modalities+1)}

