import torch.nn as nn
import torch
import torch.nn.functional as F
from experiment.main import args
from dataset.M2Reader import view_train

class Logistic(nn.Module):

    def __init__(self,size):
        super(Logistic,self).__init__()

        self.fc1 = nn.Linear(size,args.classes)
        self.bn1 = nn.BatchNorm1d(100)
        self.fc2 = nn.Linear(2,args.classes)


    def forward(self, x,vat = False,mig=False,hgr = False):

        x = self.fc1(x)
        #x = F.dropout(x,0.9)
        #x = F.relu(self.bn1(x))
        feature = x
        #feature = 0
        #x = self.fc2(feature)

        if vat:
            return x
        elif mig:
            return F.softmax(x,dim = 1)
        elif hgr:
            return feature
        else:
            return F.log_softmax(x,dim = 1)

class HGR_Linear(nn.Module):

    def __init__(self):
        super(HGR_Linear,self).__init__()

        self.fc1 = nn.Linear(100 * args.modalities,args.classes)

    def forward(self, x):

        x = self.fc1(x)

        return F.log_softmax(x,dim = 1)


H_Linear = HGR_Linear().to(args.device)
H_Optimizer = torch.optim.Adam(H_Linear.parameters(), lr = args.lr,weight_decay=1e-4)
Net = {i: Logistic(view_train[i].shape[1]).to(args.device) for i in range(1,args.modalities+1)}
Optimizer = {i: torch.optim.Adam(Net[i].parameters(), lr = args.lr,weight_decay=1e-4) for i in range(1,args.modalities+1)}
Scheduler = {i: torch.optim.lr_scheduler.StepLR(Optimizer[i],step_size=400, gamma=1) for i in range(1,args.modalities+1)}

