
import numpy as np
from sklearn.metrics import roc_auc_score, roc_curve
import copy
import logging
from sklearn import metrics
import os
import os.path as osp
from sklearn.metrics import mean_squared_error
from math import sqrt
import math

# def convert_wk(x, y):
# 	# f should be Nxk
# 	# return Nxk target
# 	grad = np.zeros(x.shape)
# 	for idx in range(x.shape[0]):
# 		inner = 0.0
# 		for ii in range(x.shape[1]):
# 			inner = inner + np.exp(x[idx, ii])
# 		for ii in range(x.shape[1]):
# 			if ii == y[idx]:
# 				grad[idx, ii] = 1 - np.exp(x[idx, y[idx]]) / inner
# 			else:
# 				grad[idx, ii] = - np.exp(x[idx, y[idx]]) / inner
# 	return grad

# line search

def generate_shuffle_index(shuffle_id):
	val_0, val_1, val_2 = 131, 199, 82
	test_0, test_1, test_2 = 218, 317, 128
	import random
	random.seed(shuffle_id)
	save_dict = {}
	list_0 = range(val_0+test_0)
	random.shuffle(list_0)
	list_1 = range(val_1 + test_1)
	random.shuffle(list_1)
	list_2 = range(val_2 + test_2)
	random.shuffle(list_2)
	save_dict['list_0'] = list_0
	save_dict['list_1'] = list_1
	save_dict['list_2'] = list_2
	return save_dict

def get_val_test_split(val_label, test_label, dicts):
	val_0, val_1, val_2 = 131, 199, 82
	test_0, test_1, test_2 = 218, 317, 128
	all_label = np.concatenate([val_label, test_label], axis=0)
	val_index = np.concatenate([np.where(all_label == 0)[0][dicts['list_0'][:val_0]],
	                            np.where(all_label == 1)[0][dicts['list_1'][:val_1]],
	                            np.where(all_label == 2)[0][dicts['list_2'][:val_2]]], axis=0)
	test_index = np.concatenate([np.where(all_label == 0)[0][dicts['list_0'][val_0:]],
	                            np.where(all_label == 1)[0][dicts['list_1'][val_1:]],
	                            np.where(all_label == 2)[0][dicts['list_2'][val_2:]]], axis=0)
	return val_index, test_index



def transform_path(path):
	if path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg2_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg2_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg3_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg3_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg4_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg4_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_Densenet_l3_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_CE_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_Densenet_l3_3_4_2_1_K_1_k_32_f_512_ReLU_iter_0_lr_0.0010_0.10_300_loss_CE_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_trans_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg3_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg3_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_200_con_0_0_me_5_0_mo_DN_l3_reg_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_7_0_mo_Densenet_l3_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_CE_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_5_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_7_0_mo_Densenet_l3_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_CE_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_5_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_con_0_0_me_7_0_mo_DN_l3_reg2_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_5_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_7_0_mo_DN_l3_reg2_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_5_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_2665_0_p_1_2664_1_1_200_con_0_0_me_5_0_mo_DN_l3_reg3_3_cr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_2665_0_par_0_p_1_2664_1_1_con_0_0_me_5_0_mo_DN_l3_reg3_3_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_300_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_0.75_gam_2.00_seg_0_cls_1_3_8_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	elif path == './results/Main_cls_seg/d_625_0_p_1_2664_1_1_con_0_0_me_3_0_mo_DN_l3_reg3_3_rr_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_10.00_gam_0.01_seg_0_cls_1_3_0_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/':
		return './results/Main_cls_seg/d_625_0_p_1_2664_1_1_con_0_0_me_3_0_mo_DN_l3_reg3_3_cc_4_2_1_K_1_k_32_f_512_ReLU_it_0_lr_0.0010_0.10_400_loss_regression_w_bat_4_pal_1_fc_n_1_dp1_0.00_reg_0.000_mul_2.0_alp_10.00_gam_0.01_seg_0_cls_1_3_0_lw_1.0000_aug_1_0_sft_5_f_1_tr_1_scl_0_1/'
	else:
		print(path)
		exit(-100)


def printed_results(temp_results, logger, opt):
	if opt.class_num == 1:
		# if opt.nb_classes == 3 and 'reg' not in opt.model:
		#	logger.info('{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f}'.
		#	            format(test_acc_list[-1] * 100.0, test_auc_list[-1] * 100.0, recall_temp[0] * 100,
		#	                   recall_temp[1] * 100, recall_temp[2] * 100, re_macro_F1[-1] * 100))
		if opt.nb_classes == 3:
			logger.info('{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & '
			            '{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {} & {} & {} & {:0.2f} & {:0.2f}'
			            .format(temp_results['acc'] * 100.0, temp_results['auc'] * 100.0,
			                    temp_results['recall_list'][-1][0] * 100.0,
			                    temp_results['recall_list'][-1][1] * 100.0,
			                    temp_results['recall_list'][-1][2] * 100.0,
			                    temp_results['precision_list'][-1][0] * 100.0,
			                    temp_results['precision_list'][-1][1] * 100.0,
			                    temp_results['precision_list'][-1][2] * 100.0,
			                    temp_results['macro_F1'] * 100.0, temp_results['micro_F_beta'] * 100.0,
			                    temp_results['macro_F_beta'] * 100.0, int(temp_results['unsure_num']),
			                    int(temp_results['gt_bengin_unsure_num']),
			                    int(temp_results['gt_mal_unsure_num']), temp_results['micro_F_beta_cc'] * 100.0,
			                    temp_results['macro_F_beta_cc'] * 100.0))
		elif opt.nb_classes == 2:
			logger.info('{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f}'
			            .format(temp_results['acc'] * 100.0, temp_results['auc'] * 100.0,
			                    temp_results['recall_list'][-1][0] * 100.0,
			                    temp_results['recall_list'][-1][1] * 100.0,
			                    temp_results['precision_list'][-1][0] * 100.0,
			                    temp_results['precision_list'][-1][1] * 100.0,
			                    temp_results['macro_F1'] * 100.0))
			# acc_str = 'acc: '
			# auc_str = 'auc: '
			# for idx in range(opt.class_num):
			# 	acc_str += '& %0.2f ' % (temp_results['acc_list'][idx] * 100.0)
			# 	auc_str += '& %0.2f ' % (temp_results['auc_list'][idx] * 100.0)
			# logger.info(acc_str)
			# logger.info(auc_str)
		elif opt.nb_classes == 5:
			logger.info('{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & '
			            '{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f}'
			            .format(temp_results['acc'] * 100.0, temp_results['auc'] * 100.0,
			                    temp_results['recall_list'][-1][0] * 100.0,
			                    temp_results['recall_list'][-1][1] * 100.0,
			                    temp_results['recall_list'][-1][2] * 100.0,
			                    temp_results['recall_list'][-1][1] * 100.0,
			                    temp_results['recall_list'][-1][2] * 100.0,
			                    temp_results['precision_list'][-1][0] * 100.0,
			                    temp_results['precision_list'][-1][1] * 100.0,
			                    temp_results['precision_list'][-1][2] * 100.0,
			                    temp_results['precision_list'][-1][1] * 100.0,
			                    temp_results['precision_list'][-1][2] * 100.0,
			                    temp_results['macro_F1'] * 100.0))

		else:
			acc_str = 'acc: '
			mean_acc = 0.0
			for idx in range(len(temp_results['acc_corr_list'])):
				acc_str += '& %0.2f ' % (temp_results['acc_corr_list'][idx] * 100.0)
				mean_acc += temp_results['acc_corr_list'][idx] * 100.0
			acc_str += '& %0.2f ' % (mean_acc / len(temp_results['acc_corr_list']))
			logger.info(acc_str)

			mse_str = 'mse: '
			mean_mse = 0.0
			for idx in range(len(temp_results['mse_list'])):
				mse_str += '& %0.4f ' % (temp_results['mse_list'][idx])
				mean_mse += temp_results['mse_list'][idx]
			mse_str += '& %0.4f ' % (mean_mse / len(temp_results['mse_list']))
			logger.info(mse_str)

		'''
		elif opt.nb_classes == 5 and 'reg' not in opt.model:
			logger.info('{:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f} & {:0.2f}'.
			            format(temp_results['acc'] * 100.0, temp_results['auc'] * 100.0, 
			                   temp_results['recall_list'][-1][0] * 100.0,
			                   recall_temp[1] * 100.0, recall_temp[2] * 100.0, recall_temp[3] * 100.0,
			                   recall_temp[4] * 100.0, re_macro_F1[-1] * 100.0))
		'''
	elif len(temp_results['mse_list']) > 0:
		acc_str = 'acc_corr: '
		mean_acc = 0.0
		for idx in range(len(temp_results['acc_corr_list'])):
			acc_str += '& %0.2f ' % (temp_results['acc_corr_list'][idx] * 100.0)
			mean_acc += temp_results['acc_corr_list'][idx] * 100.0
		acc_str += '& %0.2f ' % (mean_acc / len(temp_results['acc_corr_list']))
		logger.info(acc_str)

		mse_str = 'mse: '
		mean_mse = 0.0
		for idx in range(len(temp_results['mse_list'])):
			mse_str += '& %0.4f ' % (temp_results['mse_list'][idx])
			mean_mse += temp_results['mse_list'][idx]
		mse_str += '& %0.4f ' % (mean_mse / len(temp_results['mse_list']))
		logger.info(mse_str)

	else:
		acc_str = 'acc: '
		auc_str = 'auc: '
		mean_acc = 0.0
		mean_auc = 0.0
		for idx in range(opt.class_num):
			acc_str += '& %0.2f '%(temp_results['acc_list'][idx] * 100.0)
			auc_str += '& %0.2f ' % (temp_results['auc_list'][idx] * 100.0)
			mean_acc += temp_results['acc_list'][idx] * 100.0
			mean_auc += temp_results['auc_list'][idx] * 100.0
		acc_str += '& %0.2f '% (mean_acc/opt.class_num)
		auc_str += '& %0.2f ' % (mean_auc/opt.class_num)
		logger.info(acc_str)
		logger.info(auc_str)


def get_all_metrics(all_pred, all_labels, beta, opt, logger = None, verbose = 1):
	results = {}
	test_auc_list = []
	test_acc_list = []
	test_pre_list = []
	test_recall_list = []
	all_test_macro_F1, all_test_micro_F1, all_test_micro_pre, all_test_micro_recall = [], [], [], []
	all_test_macro_F_beta, all_test_micro_F_beta = [], []
	all_test_macro_F_beta_cc, all_test_micro_F_beta_cc = [], []
	recall_all, precision_all = [], []
	unsure_num, gt_bengin_unsure_num, gt_mal_unsure_num = [], [], []
	acc_corr_list = []
	auc_corr_list = []
	corr_list = []
	mse_list = []

	results['acc_list'] = test_auc_list
	results['mse_list'] = []

	for idx in range(opt.class_num):
		if verbose:
			logger.info('-' * 50)
			logger.info('The %dth attributes' % (idx))

		if all_pred[idx].shape[1] == 1:
			rmse_v = sqrt(mean_squared_error(all_labels[idx][all_labels[idx] >= 0.0], all_pred[idx][all_labels[idx] >= 0.0]))
			mse_list.append(rmse_v)
			corr_value = np.corrcoef(all_labels[idx][all_labels[idx] >= 0.0].reshape(all_labels[idx][all_labels[idx] >= 0.0].shape[0], ),
			                         all_pred[idx][all_labels[idx] >= 0.0].reshape(all_labels[idx][all_labels[idx] >= 0.0].shape[0], ))[0,1]
			if math.isnan(corr_value):
				corr_value = 0.0
			corr_list.append(corr_value)
			acc_corr_list.append(corr_value)
			auc_corr_list.append(corr_value)

			if verbose:
				logger.info('rmse: %0.4f'%(rmse_v))
				logger.info('corr: %0.4f' % (corr_value))

		else:
			test_pre, test_recall, test_auc, test_acc = cal_metrics(all_pred[idx], all_labels[idx],
			                                                        opt.class_config[idx], logger, verbose=verbose)
			test_auc_list.append(test_auc)
			auc_corr_list.append(np.mean(np.array(test_auc)))
			test_acc_list.append(test_acc)
			acc_corr_list.append(np.mean(np.array(test_acc)))
			test_pre_list.append(test_pre)
			test_recall_list.append(test_recall)

			all_labels[idx] = all_labels[idx].astype('int')

			recall_all.append(metrics.recall_score(all_labels[idx], np.argmax(all_pred[idx], axis=1), average=None))
			precision_all.append(metrics.precision_score(all_labels[idx], np.argmax(all_pred[idx], axis=1), average=None))


			all_test_macro_F1.append(
				get_macro_beta(all_labels[idx], np.argmax(all_pred[idx], axis=1), 1.0))
			all_test_micro_F1.append(
				metrics.f1_score(all_labels[idx], np.argmax(all_pred[idx], axis=1), average='micro'))
			all_test_micro_pre.append(
				metrics.precision_score(all_labels[idx], np.argmax(all_pred[idx], axis=1), average='micro'))
			all_test_micro_recall.append(
				metrics.recall_score(all_labels[idx], np.argmax(all_pred[idx], axis=1), average='micro'))

			all_test_macro_F_beta.append(get_macro_beta(all_labels[idx], np.argmax(all_pred[idx], axis=1), beta))
			all_test_micro_F_beta.append(get_micro_beta(all_labels[idx], np.argmax(all_pred[idx], axis=1), beta))
			all_test_macro_F_beta_cc.append(get_macro_cc(all_labels[idx], np.argmax(all_pred[idx], axis=1), beta))
			all_test_micro_F_beta_cc.append(get_micro_cc(all_labels[idx], np.argmax(all_pred[idx], axis=1), beta))

			if opt.class_num == 1 and opt.nb_classes == 3:
				unsure_num.append(np.where(np.argmax(all_pred[idx], axis=1) == 1)[0].shape[0])
				gt_bengin_unsure_num.append(np.where(np.argmax(all_pred[idx], axis=1)[all_labels[idx] == 0] == 1)[0].shape[0])
				gt_mal_unsure_num.append(np.where(np.argmax(all_pred[idx], axis=1)[all_labels[idx] == 2] == 1)[0].shape[0])

	if len(test_auc_list) > 0:
		results['auc_list'] = test_auc_list
		results['acc_list'] = test_acc_list
		results['auc'] = np.mean(np.array(test_auc_list))
		results['acc'] = np.mean(np.array(test_acc_list))
		results['precision_list'] = precision_all
		val = 0.0
		for idx in range(len(precision_all)):
			val = val + np.mean(np.array(precision_all[idx]))
		results['precision'] = val
		results['recall_list'] = recall_all
		val = 0.0
		for idx in range(len(recall_all)):
			val = val + np.mean(np.array(recall_all[idx]))
		results['recall'] = val
		results['macro_F1_list'] = all_test_macro_F1
		results['macro_F1'] = np.mean(np.array(all_test_macro_F1))
		results['micro_F1_list'] = all_test_micro_F1
		results['micro_F1'] = np.mean(np.array(all_test_micro_F1))
		results['macro_F_beta_list'] = all_test_macro_F_beta
		results['macro_F_beta'] = np.mean(np.array(all_test_macro_F_beta))
		results['micro_F_beta_list'] = all_test_micro_F_beta
		results['micro_F_beta'] = np.mean(np.array(all_test_micro_F_beta))
		results['macro_F_beta_cc_list'] = all_test_macro_F_beta_cc
		results['macro_F_beta_cc'] = np.mean(np.array(all_test_macro_F_beta_cc))
		results['micro_F_beta_cc_list'] = all_test_micro_F_beta_cc
		results['micro_F_beta_cc'] = np.mean(np.array(all_test_micro_F_beta_cc))
		results['pred'] = all_pred
		results['label'] = all_labels
		results['macro_F1_list'] = all_test_macro_F1
		results['macro_F1'] = np.mean(np.array(all_test_macro_F1))
		if opt.class_num == 1 and opt.nb_classes == 3 :
			results['unsure_num_list'] = unsure_num
			results['unsure_num'] = np.mean(np.array(unsure_num))
			results['gt_bengin_unsure_num_list'] = gt_bengin_unsure_num
			results['gt_bengin_unsure_num'] = np.mean(np.array(gt_bengin_unsure_num))
			results['gt_mal_unsure_num_list'] = gt_mal_unsure_num
			results['gt_mal_unsure_num'] = np.mean(np.array(gt_mal_unsure_num))

	if len(mse_list) > 0:
		results['mse_list'] = mse_list
		results['mse'] = np.mean(np.array(mse_list))
		results['corr_list'] = corr_list
		results['corr'] = np.mean(np.array(corr_list))
		results['acc_corr_list'] = acc_corr_list
		results['acc_corr'] = np.mean(np.array(acc_corr_list))
		results['auc_corr_list'] = auc_corr_list
		results['auc_corr'] = np.mean(np.array(auc_corr_list))

	if verbose:
		for key in results.keys():
			if 'list' not in key and 'pred' not in key and 'label' not in key:
				logger.info(key + ': ' + str(results[key]))

	return results

def get_macro_beta(labels, pred, beta):
	recall_list = metrics.recall_score(labels, pred, average=None)
	precision_list = metrics.precision_score(labels, pred, average=None)
	if len(recall_list) == 2:
		recall_ma = (recall_list[0] + beta * recall_list[1]) / (1.0 + beta)
		precision_ma = (beta * precision_list[0] + precision_list[1]) / (1.0 + beta)
	elif len(recall_list) == 3:
		recall_ma = (recall_list[0] + recall_list[1] + beta * recall_list[2]) / (2.0 + beta)
		precision_ma = (beta * precision_list[0] + precision_list[1] + precision_list[2]) / (2.0 + beta)
	elif len(recall_list) == 5 and beta == 1.0:
		recall_ma = (recall_list[0] + recall_list[1] + recall_list[2] + recall_list[3] + recall_list[4]) / 5.0
		precision_ma = (precision_list[0] + precision_list[1] + precision_list[2] + precision_list[3] + precision_list[4]) / 5.0
	else:
		return 0.0
	return 2 * recall_ma * precision_ma /(recall_ma + precision_ma)

def get_macro_cc(labels, pred, beta):
	recall_list = metrics.recall_score(labels, pred, average=None)
	precision_list = metrics.precision_score(labels, pred, average=None)
	if len(recall_list) == 2:
		recall_ma = (recall_list[0] + recall_list[1]) / (2.0)
		precision_ma = (beta * precision_list[0] + beta * precision_list[1]) / (2.0 * beta)
	elif len(recall_list) == 3:
		recall_ma = (recall_list[0] + recall_list[1] + recall_list[2]) / (3.0 )
		precision_ma = (beta * precision_list[0] + precision_list[1] + beta * precision_list[2]) / (1.0 + 2.0 * beta)
	else:
		return 0.0
	return 2 * recall_ma * precision_ma /(recall_ma + precision_ma)

def get_micro_beta(labels, pred, beta):
	cm = metrics.confusion_matrix(labels, pred)
	if cm.shape[0] == 2:
		TP = [cm[0][0], cm[1][1]]
		FN = [cm[0][1], cm[1][0]]
		FP = [cm[1][0], cm[0][1]]
		precision_mi = (1.0 * beta * TP[0] + TP[1]) / (
					beta * TP[0] + beta * FP[0] + TP[1] + FP[1])
		recall_mi = (1.0 * TP[0] + beta * TP[1]) / (TP[0] + FN[0] + beta * TP[1] + beta * FN[1])
	elif cm.shape[0] == 3:
		TP = [cm[0][0], cm[1][1], cm[2][2]]
		FN = [cm[0][1] + cm[0][2], cm[1][0] + cm[1][2], cm[2][0] + cm[2][1]]
		FP = [cm[1][0] + cm[2][0], cm[0][1] + cm[2][1], cm[0][2] + cm[1][2]]
		precision_mi = (1.0 * beta * TP[0] + TP[1] + TP[2]) / (
					beta * TP[0] + beta * FP[0] + TP[1] + FP[1] + TP[2] + FP[2])
		recall_mi = (1.0 * TP[0] + TP[1] + beta * TP[2]) / (TP[0] + FN[0] + TP[1] + FN[1] + beta * TP[2] + beta * FN[2])
	else:
		return 0.0
	return 2 * recall_mi * precision_mi / (recall_mi + precision_mi)

def get_micro_cc(labels, pred, beta):
	cm = metrics.confusion_matrix(labels, pred)
	if cm.shape[0] == 2:
		TP = [cm[0][0], cm[1][1]]
		FN = [cm[0][1], cm[1][0]]
		FP = [cm[1][0], cm[0][1]]
		precision_mi = (1.0 * beta * TP[0] + beta * TP[1]) / \
		               (beta * TP[0] + beta * FP[0] + beta * TP[1] + beta * FP[1])
		recall_mi = (1.0 * TP[0] + TP[1]) / (TP[0] + FN[0] + TP[1] + FN[1])

	elif cm.shape[0] == 3:
		TP = [cm[0][0], cm[1][1], cm[2][2]]
		FN = [cm[0][1] + cm[0][2], cm[1][0] + cm[1][2], cm[2][0] + cm[2][1]]
		FP = [cm[1][0] + cm[2][0], cm[0][1] + cm[2][1], cm[0][2] + cm[1][2]]
		precision_mi = (1.0 * beta * TP[0] + TP[1] + beta * TP[2]) / \
		               (beta * TP[0] + beta * FP[0] + TP[1] + FP[1] + beta * TP[2] + beta * FP[2])
		recall_mi = (1.0 * TP[0] + TP[1] + TP[2]) / (TP[0] + FN[0] + TP[1] + FN[1] + TP[2] + FN[2])
	else:
		return 0.0
	return 2 * recall_mi * precision_mi / (recall_mi + precision_mi)

def generate_pred_vec_reg(pred, labels, opt):
	out_full = []
	label_int = []
	if opt.class_num == 1 and opt.nb_classes == 3:
		for ii in range(len(pred)):
			out = np.zeros((pred[ii].shape[0], opt.nb_classes))
			one_label = np.zeros((pred[ii].shape[0], ))
			for idx in range(pred[ii].shape[0]):
				if opt.dataset == 2665:
					if pred[ii][idx] < 2.5:
						out[idx, 0] = 1
					elif pred[ii][idx] < 3.5:
						out[idx, 1] = 1
					else:
						out[idx, 2] = 1

					if labels[ii][idx] < 2.5:
						one_label[idx] = 0
					elif labels[ii][idx] < 3.5:
						one_label[idx] = 1
					else:
						one_label[idx] = 2
				else:
					if pred[ii][idx] < 0.5:
						out[idx, 0] = 1
					elif pred[ii][idx] < 1.5:
						out[idx, 1] = 1
					else:
						out[idx, 2] = 1

					if labels[ii][idx] < 0.5:
						one_label[idx] = 0
					elif labels[ii][idx] < 1.5:
						one_label[idx] = 1
					else:
						one_label[idx] = 2
			out_full.append(out)
			label_int.append(one_label)

	return out_full, label_int

def generate_pred_vec(pred, Lambda, opt = None, class_2 = 0):
	if class_2 == 0:
		out_full = []
		if opt.nb_classes == 2:
			for ii in range(len(pred)):
				out = np.zeros((pred[ii].shape[0], opt.nb_classes))
				for idx in range(pred[ii].shape[0]):
					if len(Lambda) == 1:
						if pred[ii][idx] <  Lambda[0]:
							out[idx, 0] = 1
						else:
							out[idx, 1] = 1

			out_full.append(out)
		elif opt.nb_classes == 3:
			for ii in range(len(pred)):
				out = np.zeros((pred[ii].shape[0], opt.nb_classes))
				for idx in range(pred[ii].shape[0]):
					if len(Lambda) == 1:
						if pred[ii][idx] < - Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[0]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 2 :
						if pred[ii][idx] < Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[1]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 2 and opt.old_type == 1:
						if pred[ii][idx] < -Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[1]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 3 :
						if pred[ii][idx] < - Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[0]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 4 :
						if pred[ii][idx] < Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[1]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 5:
						if pred[ii][idx] < - Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[0]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1
					elif len(Lambda) == 6:
						if pred[ii][idx] < Lambda[0]:
							out[idx, 0] = 1
						elif pred[ii][idx] <= Lambda[1]:
							out[idx, 1] = 1
						else:
							out[idx, 2] = 1

			out_full.append(out)

		elif opt.nb_classes > 3:
			for ii in range(len(pred)):
				out = np.zeros((pred[ii].shape[0], opt.nb_classes))
				for idx in range(pred[ii].shape[0]):
					if len(Lambda) == opt.nb_classes - 1:
						flag = 0
						for s in range(opt.nb_classes - 1):
							if pred[ii][idx] <= Lambda[s]:
								out[idx, s] = 1
								flag = 1
						if flag == 0:
							out[idx, opt.nb_classes - 1] = 1
			out_full.append(out)

	else:
		out_full = []
		# if opt is None:
		# if opt.nb_classes == 3:
		for ii in range(len(pred)):
			out = np.zeros((pred[ii].shape[0], 2))
			for idx in range(pred[ii].shape[0]):
				if len(Lambda) == 1:
					if pred[ii][idx] < 0:
						out[idx, 0] = 1
					else:
						out[idx, 1] = 1
				elif len(Lambda) == 2:
					if pred[ii][idx] < (Lambda[1] - Lambda[0])/2.0:
						out[idx, 0] = 1
					else:
						out[idx, 1] = 1
				elif len(Lambda) == 3:
					if pred[ii][idx] < 0:
						out[idx, 0] = 1
					else:
						out[idx, 1] = 1
		out_full.append(out)

	return out_full

def generate_pred_prob(pred, Lambda):
	# assume there are 3 classes
	pred_prob = np.zeros((pred.shape[0], 3))
	for ii in range(pred.shape[0]):
		exp_pos = np.exp(Lambda[1] - pred[0][ii] + np.log(Lambda[3]) + Lambda[5])
		exp_neg = np.exp(Lambda[0] - pred[0][ii] + np.log(Lambda[2]) + Lambda[4])

		term_pos_1 = np.log(1 / (1 + exp_pos))
		term_0 = np.log(exp_pos / (1 + exp_pos) - exp_neg / (1 + exp_neg))
		term_neg_1 = np.log((exp_neg) / (1 + exp_neg))

		pred_prob[ii] = np.concatenate([term_neg_1, term_0, term_pos_1], axis=1)
	return pred_prob




def softmax_np(x):
	"""Compute softmax values for each sets of scores in x."""
	return np.exp(x.astype(np.float128)) / np.tile(np.sum(np.exp(x.astype(np.float128)), axis=1)[:,np.newaxis], (1, x.shape[1]))


def f_CE(x, y):
	func = 0.0
	for idx in range(x.shape[0]):
		inner = 0.0
		for ii in range(x.shape[1]):
			inner = inner + np.exp(x[idx, ii].astype(np.float128))
		if y[idx] != -1:
			func = func - x[idx, y[idx]].astype(np.float128) + np.log(inner)
	return func

def df_CE(x, y):
	import numpy as np
	grad = np.zeros(x.shape)
	for idx in range(x.shape[0]):
		inner = 0.0
		for ii in range(x.shape[1]):
			inner = inner + np.exp(x[idx, ii].astype(np.float128))
		for ii in range(x.shape[1]):
			if y[idx] != -1:
				if ii == y[idx]:
					grad[idx, ii] = -1 + np.exp(x[idx, y[idx]].astype(np.float128)) / inner
				else:
					grad[idx, ii] = np.exp(x[idx, ii].astype(np.float128)) / inner
	return grad

def f_alpha(alpha, x, y, g):
	func = 0.0
	for idx in range(len(x)):
		func = func + f_CE(x[idx][y[idx] >= 0] + alpha * g[idx][y[idx] >= 0], y[idx][y[idx] >= 0].astype('int'))
	return func

def df_alpha(alpha, x, y, g):
	grad = 0.0
	for idx in range(len(x)):
		grad = grad + np.matrix.trace(np.dot(g[idx][y[idx] >= 0].T, df_CE(x[idx][y[idx] >= 0] + alpha * g[idx][y[idx] >= 0], y[idx][y[idx] >= 0].astype('int'))))
	return grad

def get_alpha(x0, g, beta, y, t0, logger):
	pre_alpha = 0.0
	#cur_alpha = 0.0
	counter = 0
	value = 1e10
	cur_alpha = copy.deepcopy(t0)
	while abs(value) > 1e-2:
		grad = df_alpha(cur_alpha, x0, y, g)
		# line search

		value = f_alpha(pre_alpha, x0, y, g) - f_alpha(cur_alpha , x0, y, g)# + t * np.dot(grad, df_alpha(cur_alpha, x0, y, g))
		pre_alpha = copy.deepcopy(cur_alpha)
		cur_alpha = cur_alpha - 0.01 * grad
		print(f_alpha(cur_alpha , x0, y, g))

		counter = counter + 1

		if counter >= 100:
			break

		#cur_alpha = cur_alpha + t * grad

	return cur_alpha

def get_alpha_vec(x0, g, beta, y, t0, logger, opt):
	# TODO finish this func
	pre_alpha = np.zeros((opt.class_num, )).astype('float')
	#cur_alpha = 0.0
	counter = 0
	value = 1e10
	cur_alpha = t0 * np.ones((opt.class_num, )).astype('float')
	f_pre_alpha = np.zeros((opt.class_num,)).astype('float')
	f_cur_alpha = np.zeros((opt.class_num,)).astype('float')
	grad = np.zeros((opt.class_num,)).astype('float')

	while abs(value) > 1e-2:
		for ii in range(len(x0)):
			grad[ii] = df_alpha(cur_alpha[ii], [x0[ii]], [y[ii]], [g[ii]])
		# line search
		for ii in range(len(x0)):
			f_pre_alpha[ii] = f_alpha(pre_alpha[ii], [x0[ii]], [y[ii]], [g[ii]])

		for ii in range(len(x0)):
			f_cur_alpha[ii] = f_alpha(cur_alpha[ii], [x0[ii]], [y[ii]], [g[ii]])
		#value = f_alpha(pre_alpha, x0, y, g) - f_alpha(cur_alpha , x0, y, g)# + t * np.dot(grad, df_alpha(cur_alpha, x0, y, g))

		if opt.alpha_vec == 1:
			value = 0.0
			for ii in range(len(x0)):
				value = value + f_pre_alpha[ii] - f_cur_alpha[ii]
				pre_alpha[ii] = copy.deepcopy(cur_alpha[ii])
				cur_alpha[ii] = cur_alpha[ii] - 0.01 * grad[ii]
		#print f_alpha(cur_alpha , x0, y, g)

		counter = counter + 1

		if counter >= 100:
			break

		#cur_alpha = cur_alpha + t * grad

	return cur_alpha


def get_alpha_mix(x0, g, beta, y, t0, logger):
	pre_alpha = 0.0
	#cur_alpha = 0.0
	counter = 0
	value = 1e10
	cur_alpha = copy.deepcopy(t0)
	while abs(value) > 1e-2:
		for ii in range(len(x0)):
			if ii == 0:
				grad = df_alpha(cur_alpha, [x0[0]], [y[0]], [g[0]])
			else:
				grad = grad + 2 * np.mean(g[ii][y[ii] >= 0] * (x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))))
		# line search
		for ii in range(len(x0)):
			if ii == 0:
				f_pre_alpha = f_alpha(pre_alpha, [x0[0]], [y[0]], [g[0]])
			else:
				f_pre_alpha = f_pre_alpha + np.mean((x0[ii][y[ii] >= 0] + pre_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

		for ii in range(len(x0)):
			if ii == 0:
				f_cur_alpha = f_alpha(cur_alpha, [x0[0]], [y[0]], [g[0]])
			else:
				f_cur_alpha = f_pre_alpha + np.mean((x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

		value = f_pre_alpha - f_cur_alpha# + t * np.dot(grad, df_alpha(cur_alpha, x0, y, g))
		pre_alpha = copy.deepcopy(cur_alpha)
		cur_alpha = cur_alpha - 0.01 * grad
		print(f_cur_alpha)

		counter = counter + 1

		if counter >= 100:
			break

		#cur_alpha = cur_alpha + t * grad

	return cur_alpha

def get_alpha_mse(x0, g, beta, y, t0, logger, opt):
	if opt.alpha_vec == 1:
		pre_alpha = np.zeros((opt.class_num, )).astype('float')
		counter = 0
		value = 1e20 * np.ones((opt.class_num, )).astype('float')
		cur_alpha = t0 * np.ones((opt.class_num, )).astype('float')
	else:
		pre_alpha = 0.0
		counter = 0
		value = 1e10
		cur_alpha = copy.deepcopy(t0)
	while abs(value) > 1e-2:
		if opt.loss == 'MSE_med' or opt.loss == 'MSE_max':
			for ii in range(len(x0)):
				if ii == 0:
					grad = 2 * np.mean((g[ii][y[ii] >= 0] * (
								x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape(
							(y[ii][y[ii] >= 0].shape[0], 1)))) * (1.0 / opt.cw[ii] ** 2))
				else:
					grad = grad + 2 * np.mean((g[ii][y[ii] >= 0] * (
								x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape(
							(y[ii][y[ii] >= 0].shape[0], 1)))) * (1.0 / opt.cw[ii] ** 2))
			# line search
			for ii in range(len(x0)):
				if ii == 0:
					f_pre_alpha = np.mean(((x0[ii][y[ii] >= 0] + pre_alpha * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))
				else:
					f_pre_alpha = f_pre_alpha + np.mean(((x0[ii][y[ii] >= 0] + pre_alpha * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))

			for ii in range(len(x0)):
				if ii == 0:
					f_cur_alpha = np.mean(((x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))
				else:
					f_cur_alpha = f_pre_alpha + np.mean(((x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))

		else:
			for ii in range(len(x0)):
				if ii == 0:
					grad = 2 * np.mean(g[ii][y[ii] >= 0] * (x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))))
				else:
					grad = grad + 2 * np.mean(g[ii][y[ii] >= 0] * (x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))))
			# line search
			for ii in range(len(x0)):
				if ii == 0:
					f_pre_alpha = np.mean((x0[ii][y[ii] >= 0] + pre_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)
				else:
					f_pre_alpha = f_pre_alpha + np.mean((x0[ii][y[ii] >= 0] + pre_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

			for ii in range(len(x0)):
				if ii == 0:
					f_cur_alpha = np.mean((x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)
				else:
					f_cur_alpha = f_pre_alpha + np.mean((x0[ii][y[ii] >= 0] + cur_alpha * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

		if opt.alpha_vec == 1:
			pass
		else:
			value = np.mean(f_pre_alpha) - np.mean(f_cur_alpha)# + t * np.dot(grad, df_alpha(cur_alpha, x0, y, g))
			pre_alpha = copy.deepcopy(cur_alpha)
			cur_alpha = cur_alpha - 0.01 * np.mean(grad)
		#print f_cur_alpha

		counter = counter + 1

		if counter >= 100:
			break

		#cur_alpha = cur_alpha + t * grad

	return cur_alpha

def get_alpha_mse_vec(x0, g, beta, y, t0, logger, opt):
	if opt.alpha_vec == 1:
		pre_alpha = np.zeros((opt.class_num, )).astype('float')
		counter = 0
		value = 1e20
		cur_alpha = t0 * np.ones((opt.class_num, )).astype('float')
		f_pre_alpha = np.zeros((opt.class_num, )).astype('float')
		f_cur_alpha = np.zeros((opt.class_num, )).astype('float')
		grad = np.zeros((opt.class_num,)).astype('float')

	while abs(value) > 1e-2:
		if opt.loss == 'MSE_med' or opt.loss == 'MSE_max':
			for ii in range(len(x0)):
				grad[ii] = 2 * np.mean((g[ii][y[ii] >= 0] * (
								x0[ii][y[ii] >= 0] + cur_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape(
							(y[ii][y[ii] >= 0].shape[0], 1)))) * (1.0 / opt.cw[ii] ** 2))
			# line search
			for ii in range(len(x0)):
				f_pre_alpha[ii] = np.mean(((x0[ii][y[ii] >= 0] + pre_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))

			for ii in range(len(x0)):
				f_cur_alpha[ii] = np.mean(((x0[ii][y[ii] >= 0] + cur_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][
						y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2) * (1.0 / opt.cw[ii] ** 2))

		else:
			for ii in range(len(x0)):
				grad[ii] = 2 * np.mean(g[ii][y[ii] >= 0] * (x0[ii][y[ii] >= 0] + cur_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))))
			# line search
			for ii in range(len(x0)):
				f_pre_alpha[ii] = np.mean((x0[ii][y[ii] >= 0] + pre_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

			for ii in range(len(x0)):
				f_cur_alpha[ii] = np.mean((x0[ii][y[ii] >= 0] + cur_alpha[ii] * g[ii][y[ii] >= 0] - y[ii][y[ii] >= 0].reshape((y[ii][y[ii] >= 0].shape[0], 1))) ** 2)

		if opt.alpha_vec == 1:
			value = 0.0
			for ii in range(len(x0)):
				value = value + f_pre_alpha[ii] - f_cur_alpha[ii]
				pre_alpha[ii] = copy.deepcopy(cur_alpha[ii])
				cur_alpha[ii] = cur_alpha[ii] - 0.01 * grad[ii]


		counter = counter + 1

		if counter >= 100:
			break

		#cur_alpha = cur_alpha + t * grad

	return cur_alpha


def backtrack_k(x0, g, f, dfx, alpha, beta, y, t, logger):
	# x0 is the start point list
	# g is direction list
	# dfx is the gradient func
	# alpha is step size
	# beta is search parameter
	# y is label list
	count = 0

	#t = - np.matrix.trace(np.dot(g.T, dfx(x0, y)))
	value = 0.0
	for idx in range(len(y)):
		value = value + (f(x0[idx], y[idx].astype('int')) - f(x0[idx] + t * g[idx], y[idx].astype('int')) +
						 alpha * t * np.matrix.trace(np.dot(g[idx].T, dfx(x0[idx], y[idx].astype('int')))))

	while value < 0:
		t *= beta
		logger.info("iteration: {}".format(count))
		value = 0.0
		for idx in range(len(y)):
			value = value + (f(x0[idx], y[idx].astype('int')) - f(x0[idx] + t * g[idx], y[idx].astype('int')) +
							 alpha * t * np.matrix.trace(np.dot(g[idx].T, dfx(x0[idx], y[idx].astype('int')))))

		logger.info("Inequality: %d"%value)
		count += 1
	return t

def backtrack(x0, g, f, dfx, alpha, beta, y, t, logger):
	# x0 is the start point
	# g is direction
	# dfx is the gradient func
	# alpha is step size
	# beta is search parameter


	count = 0

	#t = - np.matrix.trace(np.dot(g.T, dfx(x0, y)))
	while (f(x0, y) - f(x0 + t * g, y) + alpha * t * np.matrix.trace(np.dot(g.T, dfx(x0, y)))) < 0:
		t *= beta
		logger.info("iteration: {}".format(count))
		logger.info("Inequality: ", f(x0, y) - f(x0 + t * g, y) + alpha * t * np.matrix.trace(np.dot(g.T, dfx(x0, y))))
		count += 1
	return t

# for dataset loader
def convert_label(label, att_idx, merge = 1):
	#print label
	if merge == 8  or merge == 9 or merge == 10:
		return label
	if merge == 7:
		if att_idx == 8:
			if label < 1.5:
				return 0
			elif label < 2.5:
				return 1
			elif label < 3.5:
				return 2
			elif label < 4.5:
				return 3
			else:
				return 4
		else:
			if label < 3.0:
				return 0
			else:
				return 1

	if merge == 6:
		if att_idx == 8:
			if label < 2.5:
				return 0
			elif label < 3.5:
				return 1
			else:
				return 2
		else:
			if label < 3.0:
				return 0
			else:
				return 1

	if merge == 5:
		if label < 2.5:
			return 0
		elif label < 3.5:
			return 1
		else:
			return 2
	if merge == 3:
		return int(label)
	else:
		if att_idx in [0,3,4,5,6,7,8]:
			if merge == 1:
				if label < 2.5:
					return 0
				elif label < 3.5:
					return 2
				else:
					return 1
			elif merge == 2:
				if label < 3:
					return 0
				else:
					return 1
			elif merge == 4:
				if label < 2.5:
					return 0
				elif label < 3.5:
					return -1
				else:
					return 1

		elif att_idx == 1:
			if label < 1.5:
				return 0
			else:
				return 1

		elif att_idx == 2:
			if label >= 5.5:
				return 1
			else:
				return 0
		else:
			print('bad att_idx ot label')
			return -1


# for dataloader
def compute_nodule_size(mask):
	# mask is xyz
	index = np.where(mask == 1)
	min_x, max_x = min(index[0]), max(index[0])
	min_y, max_y = min(index[1]), max(index[1])
	min_z, max_z = min(index[2]), max(index[2])
	return (int(max_x - min_x) + 1, int(max_y - min_y) + 1, int(max_z - min_z) + 1)

def get_auc_acc_string(results_list, seg_results = None, type = 'acc'):
	strs = ""
	strs += "{}: ".format(type)
	for idx in range(len(results_list)):
		strs += " {:0.2f} |".format(results_list[idx] * 100.0)
	strs += " {:0.2f} |".format(np.mean(np.array(results_list)) * 100.0)
	if seg_results is not None:
		strs += " {:0.2f} |".format(seg_results.avg * 100)

	return strs

def get_results_string(epoch, iteration, len_loader, batch_time, losses,
								segmentation, classification, epoch_results=False):
	strs = ""
	if not epoch_results:
		strs += "===> Epoch[{}]({}/{}): Time: {batch_time.val:.2f} ({batch_time.avg:.2f}), Loss: {loss.val:.4f} ({loss.avg:.4f})), Segmentation: {segmentation.val:.4f} ({segmentation.avg:.4f}) ".format(epoch, iteration, len_loader, batch_time=batch_time, loss=losses,
			segmentation=segmentation)

		for idx in range(len(classification)):
			strs += " Class: {classification.val:.2f} ({classification.avg:.2f}), ".format(classification=classification[idx])

	else:
		strs += "===> Epoch {} Traing Complete: Avg. Loss: {:.4f}, Segmentation : {segmentation.avg:.4f}, Class: ".format(epoch, losses.avg, segmentation=segmentation)

		for idx in range(len(classification)):
			strs += "{classification.val:.2f}, ".format(
				classification=classification[idx])
	return strs

def is_better(before_set, query):
	# before_set is a dict with 0,1,2,3,4 keys and [opt.class_num] results
	# query should be [opt.class_num]
	# attr_num = len(query)
	# consider multi-best condition
	key_list = []
	attr_num = len(query)
	for key in before_set:
		if check_better(before_set[key]['val_acc'], query) == attr_num:
			key_list.append(key)
	if len(key_list) > 0:
		return True, key_list
	else:
		return False, -1

def is_one_better(before_set, query):
	# before_set is a dict with 0,1,2,3,4 keys and [opt.class_num] results
	# query should be [opt.class_num]
	# attr_num = len(query)
	# consider multi-best condition
	key_list = []
	attr_num = len(query)
	counter = 0
	for key in before_set:
		if check_better(before_set[key]['val_acc'], query) > 0:
			counter += 1
	for idx in range(500):
		if idx not in before_set.keys():
			not_used_key = idx
			break

	if counter == len(before_set):
		return True, not_used_key
	else:
		return False, -1

def check_better(perform1, perform2):
	# is perform2 better than 1
	flag = 0
	for s in range(len(perform1)):
		if perform1[s] <= perform2[s]:
			flag += 1
	return flag

def cal_accuracy_class(target, gt):
	pred_labels = np.argmax(target, axis =1)
	gt_shape = gt.reshape(pred_labels.shape)
	accuracy = (pred_labels == gt_shape)
	return np.sum(accuracy)*100/np.shape(accuracy)[0], target

class AverageMeter(object):
	"""Computes and stores the average and current value"""
	def __init__(self):
		self.reset()

	def reset(self):
		self.val = 0
		self.avg = 0
		self.sum = 0
		self.count = 0

	def update(self, val, n=1):
		self.val = val
		self.sum += val * n
		self.count += n
		self.avg = self.sum / self.count

def cal_metrics(all_pred, all_labels, n_classes, logger, verbose = 1):
	all_labels = all_labels.astype('int')
	all_gt = np.zeros((len(all_labels), n_classes))
	auc = []
	#all_gt_2 = np.zeros((len(all_labels), 2))
	#all_pred_2 = copy.deepcopy(all_pred)
	select_idx = []
	for idx, one_label in enumerate(all_labels):
		if one_label != -1:
			select_idx.append(idx)
			all_gt[idx, one_label] = 1
	for idx in range(n_classes):
		try:
			auc.append(metrics.roc_auc_score(all_gt[select_idx, idx], all_pred[select_idx, idx], average=None))
		except ValueError:
			if verbose:
				logger.info('error in compute auc')
			auc.append(0.0)
	all_pred_labels = np.argmax(all_pred[select_idx,:], axis=1)
	precision = metrics.precision_score(all_labels[select_idx], all_pred_labels, average=None)
	recall = metrics.recall_score(all_labels[select_idx], all_pred_labels, average=None)
	acc = metrics.accuracy_score(all_labels[select_idx], all_pred_labels)
	if verbose:
		logger.info('total accuracy is ' + str(acc))
		flag_i = 0
		for i in range(n_classes):
			logger.info('AUC:class_' + str(i) + ':' + str(auc[i]))

		flag_i = 0
		for i in range(n_classes):
			if i not in set(all_labels):
				logger.info('Precision:class_' + str(i) + ':' + str(0.0))
				flag_i += 1
			else:
				logger.info('Precision:class_' + str(i) + ':' + str(precision[i - flag_i]))

		flag_i = 0
		for i in range(n_classes):
			if i not in set(all_labels):
				logger.info('Recall:class_' + str(i) + ':' + str(0.0))
				flag_i += 1
			else:
				logger.info('Recall:class_' + str(i) + ':' + str(recall[i - flag_i]))

	average_precision = np.mean(precision)
	average_recall = np.mean(recall)
	average_auc = np.mean(auc)
	if n_classes == 2:
		return average_precision, average_recall, auc[1], acc
	else:
		return average_precision, average_recall, average_auc, acc


def checkpoint(epoch, save_folder, save_model, opt, val_dice = 0.0, test_dice = 0.0):
	import torch
	if val_dice == 0.0:
		model_out_tar_path = osp.join(save_folder, "model_epoch_{}.pth.tar".format(epoch))
	else:
		model_out_tar_path = osp.join(save_folder, "model_epoch_{}_{:0.4f}_{:0.4f}.pth.tar".format(epoch, val_dice, test_dice))

	torch.save({
		'state_dict':save_model.state_dict(),
		'epoch':epoch,
		'opt':opt
	},model_out_tar_path)
	print("Checkpoint saved to {}".format(model_out_tar_path))

def save_checkpoint(state, save_folder, filename='checkpoint.pth.tar'):
	import torch
	"""Saves checkpoint to disk"""
	directory = save_folder
	if not os.path.exists(directory):
		os.makedirs(directory)
	filename = osp.join(directory, filename)
	torch.save(state, filename)

def get_logger(opt, fold):
	logger = logging.getLogger('AL')
	logger.setLevel(level=logging.INFO)
	handler = logging.FileHandler('{}training_{}.log'.format(opt.file_dir, fold))
	handler.setLevel(logging.INFO)
	formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
	handler.setFormatter(formatter)
	console = logging.StreamHandler()
	console.setLevel(logging.INFO)
	console.setFormatter(formatter)
	logger.addHandler(handler)
	logger.addHandler(console)
	return logger

def adjust_learning_rate(optimizer, epoch, opt):
	"""Sets the learning rate to the initial LR decayed by 10 after 150 and 225 epochs"""
	#lr = config.lr * (0.1 ** (epoch // config.lr_controler)) #* (0.1 ** (epoch // 35))
	#lr = config.lr * (1 - float(epoch) / config.epochs) ** 0.9 # for segmentation
	if not(opt.optimizer == 'Adam'):
		lr = opt.lr * (opt.lr_decay ** (epoch // opt.lr_controler))
		#if opt.face_lr:
		#    if epoch // opt.lr_controler >2:
		#        lr = opt.lr * (0.1 ** 2) /2
		for param_group in optimizer.param_groups:
			param_group['lr'] = lr
	else:
		if opt.iter_l:
			opt.lw_class = opt.lw_class * (100 * (epoch // opt.lr_controler))
		lr = opt.lr * (opt.lr_decay ** (epoch // opt.lr_controler))
		for param_group in optimizer.param_groups:
			param_group['lr'] = lr


def tuning_threshold(y_label, y_score, threshold_find=0.99, threshold = None, verbose=True):
	choose_threshold = []
	y_score = np.array(y_score)
	y_label = np.array(y_label)
	specificity_thred = None
	if threshold == None:
		fpr, tpr, threshold = roc_curve(y_label, y_score, drop_intermediate=False)
		min_threshold, max_threshold = min(threshold), max(threshold)
		thresholds = np.linspace(min_threshold, max_threshold, 500)[::-1]
		for index, thred in enumerate(thresholds):
			y_pred = (y_score >= thred).astype(int)
			current_result = calc_metrics_for_fine_tuning_threshold(y_label, y_pred, verbose=False)
			sensitivity, specificity = current_result['Sen'], current_result['Spe']
			choose_threshold.append((sensitivity, specificity))
		for index in range(len(choose_threshold)):
			if index != 0:
				if choose_threshold[index-1][1] >= threshold_find and choose_threshold[index][1] <= threshold_find:
					sensitivity_thred =  choose_threshold[index-1][0]
				if choose_threshold[index-1][0] <= threshold_find and choose_threshold[index][0] >= threshold_find:
					specificity_thred =  choose_threshold[index][1]
		if specificity_thred == None:
			return {'threshold':threshold_find, 'sen': 0, 'spe': 0}
		if verbose==True:
			pass
			#print((sensitivity_thred, specificity_thred))
		result = {'threshold':threshold_find, 'sen': sensitivity_thred, 'spe': specificity_thred}
		return result


def calc_metrics_for_fine_tuning_threshold(act, pred, verbose=False):
	epsilon = 1e-6
	tp = epsilon
	fp = epsilon
	fn = epsilon
	tn = epsilon
	act = list(act)
	pred = list(pred)
	for i in range(len(act)):
		if act[i] == 1 and pred[i] == 1:
			tp += 1
		elif act[i] == 1 and pred[i] == 0:
			fn += 1
		elif act[i] == 0 and pred[i] == 1:
			fp += 1
		else:
			tn += 1
	p = tp / (tp + fp)
	r = tp / (tp + fn)
	f = 2 * p * r / (p + r)
	acc = (tp + tn) / (fp + fn + tp + tn)
	sen = tp / (tp + fn)
	spe = tn / (tn + fp)
	ppv = tp / (tp + fp)
	npv = tn / (tn + fn)
	if verbose:
		# print('        AUC\t', auc_val)
		print('Sensitivity\t', sen)
		print('Specificity\t', spe)
		print('         F1\t', f)
		print('  Precision\t', p)
		print('     Recall\t', r)
		print('   Accuracy\t', acc)
		print('        PPV\t', ppv)
		print('        NPV\t', npv)
	result = {}

	result['pre'] = p
	result['rec'] = r
	result['f1'] = f
	result['Sen'] = sen
	result['Spe'] = spe
	result['Acc'] = acc
	# result['PPV'] = ppv
	# result['NPV'] = npv
	return result

def cal_acc_vec(pred, gt, best = 0, compute_thres = False):
	auc = 0.0
	try:
		auc = roc_auc_score(gt, pred)
		if compute_thres:
			gt_copy = copy.deepcopy(gt)
			pred_copy = copy.deepcopy(pred)
			results = tuning_threshold(gt_copy, pred_copy)
			print('sen 99%:', results['spe'])
			print('spe 99%:', results['sen'])
	except:
		pass
	raw_pred = copy.deepcopy(pred)
	if best == 1:
		theshold = list(np.linspace(0.05, 0.95, 19))
		acc = 0.0
		for thes in theshold:
			raw_pred[pred>=thes] = 1
			raw_pred[pred<thes] = 0
			eps = 1e-8
			tp, tn, fp, fn = 0.0, 0.0, 0.0, 0.0
			for i in range(raw_pred.shape[0]):
				if raw_pred[i, 1] == 1 and gt[i, 1] == 1:
					tp = tp + 1
				elif raw_pred[i, 1] == 0 and gt[i, 1] == 0:
					tn = tn + 1
				elif raw_pred[i, 1] == 1 and gt[i, 1] == 0:
					fp = fp + 1
				elif raw_pred[i, 1] == 0 and gt[i, 1] == 1:
					fn = fn + 1
			acc_t = (tp + tn) / (tp + fp + fn + tn + eps)
			if acc_t > acc:
				acc = acc_t
				sensitivity = tp / (tp + fn + eps)
				specificity = tn / (tn + fp + eps)
				PPV = tp / (tp + fp + eps)
				FPV = tn / (tn + fn + eps)
				best_thes = thes
		return acc, auc, sensitivity, specificity, PPV, FPV, best_thes
	else:
		raw_pred[pred >= 0.5] = 1
		raw_pred[pred < 0.5] = 0
		eps = 1e-8
		tp, tn, fp, fn = 0.0, 0.0, 0.0, 0.0
		for i in range(raw_pred.shape[0]):
			if raw_pred[i] == 1 and gt[i] == 1:
				tp = tp + 1
			elif raw_pred[i] == 0 and gt[i] == 0:
				tn = tn + 1
			elif raw_pred[i] == 1 and gt[i] == 0:
				fp = fp + 1
			elif raw_pred[i] == 0 and gt[i] == 1:
				fn = fn + 1
		acc = (tp + tn) / (tp + fp + fn + tn + eps)
		sensitivity = tp / (tp + fn + eps)
		specificity = tn / (tn + fp + eps)
		PPV = tp / (tp + fp + eps)
		FPV = tn / (tn + fn + eps)
	return acc, auc, sensitivity, specificity, PPV, FPV


def cal_acc(pred, gt):
	#pred = np.argmax(pred, axis=1)
	gt = gt.reshape(gt.shape[0],gt.shape[2],gt.shape[2],gt.shape[2])
	pred[pred>=0.5] = 1
	pred[pred<0.5] = 0
	gt[gt>=0.5] = 1
	pred = pred.reshape(gt.shape)
	dice, sensitivity, PPV, acc = 0, 0, 0, 0
	for i in range(pred.shape[0]):
		p_dice, p_sensitivity, p_PPV, p_acc = perimag_acc(pred[i,:,:,:], gt[i,:,:,:])
		dice += p_dice
		sensitivity += p_sensitivity
		PPV += p_PPV
		acc += p_acc
	return dice/pred.shape[0], sensitivity/pred.shape[0], PPV/pred.shape[0], acc/pred.shape[0]

def perimag_acc(pred, gt):
	#input must be numpy arrays; pred is 4D tensor and gt is 3D tensor
	smooth = 1.0
	tp = np.sum(pred[np.where(gt==1)])
	fp = np.where(pred[np.where(gt==1)] == 0)[0].shape[0]
	acc = np.sum(pred==gt)/(np.prod(gt.shape)*1.0)
	dice = (np.sum(pred[np.where(gt==1)])*2.0 + smooth) / (np.sum(pred) + np.sum(gt) + smooth)
	sensitivity = (tp + smooth) / (np.sum(gt) + smooth)
	PPV = (tp + smooth) / (np.sum(pred) + smooth)

	return dice, sensitivity, PPV, acc

#only for inter-dsc computation
def dsc_computation(label, pred):
	smooth = 1.0
	pred = (pred>=0.5)
	label = (label>=0.5)
	pred = pred.flatten()
	label = label.flatten()
	assert pred.shape == label.shape, 'shapes do not match'
	label_sum = label.sum()
	pred_sum = pred.sum()
	inter_sum = np.logical_and(pred, label).sum()
	return (2 * float(inter_sum)+smooth) / (pred_sum + label_sum + smooth
											), inter_sum, pred_sum, label_sum